﻿
package samples {
	
	// FALCONPROVIDER INTRODUCTION  
	// FalconProvider lets you send and receive data with one class 
	// the difference between this class and Falcon is that this class puts data into a DataProvider
	// use Falcon if you are not using a DataProvider for a DataGrid, ComboBox, List component etc.

	// http://falconflash.wordpress.com - by inventor Dan Zen - http://www.danzen.com
	// if you are using FalconProvider for commercial purposes, you are welcome to donate to Dan Zen
	// donations can be made to agency@danzen.com at http://www.paypal.com
		
	// INSTALLING CLASSES
	// suggested installation:
	// create a "classes" folder on your hard drive - for example c:\classes
	// add the classes folder to your Flash class path:
	// Flash menu choose Edit > Preferences > ActionScript - ActionScript 3 Settings 
	// then use the + sign for the source path box to add the path to your classes folder	
	// put the provided com/danzen/ directory with its folders and files in the classes folder
	// the readme has more information if you need it
	
	// USING FALCONPROVIDER
	// Below is how to call FalconProvider from our document class
	// you must have a component that uses a DataProvider in the library (DataGrid, ComboBox, List)
	// you create a new FalconProvider Object and pass it the URL, dataType and variables to send (optional)
	// addEventListener to receive the Event.COMPLETE event and in the event method
	// you can set the dataProvider property of your component to the FalconProvider's dataProvider property
	// your server script (like PHP) must return a cgi-formated variables with an increasing index number like so:
	// age1=29&name1=Dan&age2=32&name2=Roger&age3=22&name3=Paula etc.
	// make a new Object each time you want to send or receive data
	

	// CONSTRUCTOR
	// new FalconProvider(serverFile:String, type:String = Falcon.VARIABLES, myVars:Object = {});
	//		Parameters:
	//		serverFile is the name of your server script like a php file
	//		type for FalconProvider should be Falcon.VARIABLES (default)
	//		can use FalconProvider for other types if you want
	
	//  METHODS
	//	none
	
	//  PROPERTIES
	//	data:*	populated just before the COMPLETE event is dispatched
	//			holds your Variables just ask for data.yourVariable
	//	dataProvider:DataProvider
	//			holds a DataProvider created based on your script input
	//			script must send back variables with an increasing index
	//  error:Boolean
	//			whether there was an error or not
	//			will not capture an error if 
	
	//  CONSTANTS
	//  Falcon.VARIABLES:String
	//	Falcon.TEXT:String
	//	Falcon.XML_DATA:String
	//	Falcon.BINARY:String		
	
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.text.TextField;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import fl.data.DataProvider;
	
	import com.danzen.utilities.FalconProvider;
	
	public class FalconDataProvider extends MovieClip {
		// this code uses the FalconProvider class to send and load variables
		// FalconProvider is a class like Falcon that wraps the half dozen Flash data classes
		// FalconProvider also creates a dataProvider for sequenced data (name1, name2, name3, etc.)
		// You must have a component that uses a DataProvider in the Library of the FLA
		private var myFalcon:FalconProvider;
		private var myScriptURL:String = "http://www.yourserver.com/falconDataProvider.php";
		private var myDataType:String = FalconProvider.VARIABLES;
		private var mySendVars:Object = new Object; // object for sending variables
		public function FalconDataProvider() {
			getData();
			mySubmit.addEventListener(MouseEvent.CLICK, submitData);
		}
		function getData(myFirstName:String="", myLastName:String="", myFear:String="") {
			// preparing data to send to the server script
			mySendVars.firstName = myFirstName;
			mySendVars.lastName = myLastName;
			mySendVars.fear = myFear;

			// here we create a Falcon Object to send and receive data from the server script
			myFalcon = new FalconProvider(myScriptURL, myDataType, mySendVars);
			myFalcon.addEventListener(Event.COMPLETE, showGrid);
		}
		private function showGrid(e:Event) {
			if (e.target.error) {
				trace("there was an error connecting to the server");
			} else if (e.target.data.error != 0) {// (optional) we are sending a error check from the server script
				trace(e.target.data.error);
			} else {
				// if variables are sent with number iterators like:
				// name1, age1, name2, age2, etc. (or name0, age0, name1, age1, etc.)
				// then these are put in e.target.dataProvider as name, age, etc.
				// this allows you to populate DataGrid objects as below
				// or populate List and ComboBox objects using label1, data1, label2, data2, etc.
				myGrid.columns = ["firstName", "lastName", "fear"];
				myGrid.dataProvider = e.target.dataProvider;
				myGrid.getColumnAt(0).headerText = "First Name";
				myGrid.getColumnAt(0).width = 90;
				myGrid.getColumnAt(1).headerText = "Last Name";
				myGrid.getColumnAt(1).width = 90;
				myGrid.getColumnAt(2).headerText = "Greatest Fear";
			}
		}
		function submitData(e:MouseEvent) {
			if (firstName.text == "" || lastName.text == "" || fear.text == "") {
				navigateToURL(new URLRequest("javascript:alert('Please enter all fields');"), "_self");
			} else {
				getData(firstName.text, lastName.text, fear.text);
				firstName.text = lastName.text = fear.text = "";
			}
		}
	}
}