﻿
package samples {
	
	// FALCON INTRODUCTION  
	// Falcon lets you send and receive data with one class
	// use Falcon to read in text or XML or communicate with a server script like PHP
	// See FalconProvider to see how you can easily get server data into a DataProvider (DataGrid, List, etc.)
		
	// INSTALLING CLASSES
	// suggested installation:
	// create a "classes" folder on your hard drive - for example c:\classes
	// add the classes folder to your Flash class path:
	// Flash menu choose Edit > Preferences > ActionScript - ActionScript 3 Settings 
	// then use the + sign for the source path box to add the path to your classes folder	
	// put the provided com/ directory with its folders and files in the classes folder
	// the readme has more information if you need it
	
	// USING FALCON
	// See below for an example of how to call Falcon from a document class for instance	
	// you basically, create a new Falcon Object and pass it the URL, dataType and variables to send (optional)
	// addEventListener to receive the Event.COMPLETE event and ask for your Falcon object's data property
	// make a new Object each time you want to send or receive data
	// if you just want to send data to a server script you still must receive data in cgi-format
	// so just have your server script return status=good or some such key=value pair
	
	// CONSTRUCTOR
	// new Falcon(serverFile:String, type:String = Falcon.VARIABLES, myVars:Object = {});
	//		Parameters:
	//		serverFile is the name of your XML or txt file or server script like a php file
	//		type is Falcon.VARIABLES, Falcon.TEXT, Falcon.XML_DATA, Falcon.BINARY
	//		you can't write to TEXT, XML_DATA or BINARY files 
	//		use VARIBLES and a server script to write to these types of files
	
	//  METHODS
	//	none
	
	//  PROPERTIES
	//	data	populated just before the COMPLETE event is dispatched
	//			holds your XML, Text, Binary or Variable data
	//			for XML it is XML
	//			for Variables just ask for data.yourVariable
	
	//  CONSTANTS
	//  Falcon.VARIABLES:String
	//	Falcon.TEXT:String
	//	Falcon.XML_DATA:String
	//	Falcon.BINARY:String	
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.text.TextField;

	import com.danzen.utilities.Falcon;

	public class FalconMultipleVariables extends MovieClip {

		public function FalconMultipleVariables() {
			
			// create a new object to hold the variables you want to send
			// put whatever data you want to send into the variables object
			// you can name the variables what you want, here we called them var1 and var2
			// you can make as many as you want
			// if you do not have anything to send, just don't make and pass the object
			// you can move the lines below into a button event function
			// this would allow to to set your variables from data in a TextField, etc.
			
			var myVars:Object = new Object();
			myVars.var1 = "hello"; 
			myVars.var2 = "goodbye";
			
			// create a Falcon object and pass it your script, the type of data and the object with your variables
			// you need to change the URL below to go to your php page
			
			var myFalcon:Falcon = new Falcon("http://www.yourserver.com/falconMultipleVariables.php", Falcon.VARIABLES, myVars);
			myFalcon.addEventListener(Event.COMPLETE, getData);
			
		}
		
		private function getData(e:Event) {
			if (e.target.error) {
				myText.text = "sorry, error connecting to server script";
			} else {
				myText.text = e.target.data.newVar1 + "\n" + e.target.data.newVar2;
			}
		}
		
	}
}